#include <iostream>
#include <string>
#include <stdlib.h>
#include <sstream>
#include <fstream>


#include "expression.h"
#include "mesh.h"
#include "monge.h"

typedef filib::interval<double,filib::native_switched,filib::i_mode_extended> interval;


// Entry point
int main(int argc, char *argv[])
{

   expression f("1");
   expression g("(3/2)*(-(y^2)+1)");

   int nb = 300; //découpage de l'espace
   
   expression cout("(x-y)^2");

   monge mon_monge(f,g,cout);

   mon_monge.construit_marginale(nb);
   mon_monge.construit_cout(nb);
   double z = mon_monge.dual(nb);

   ofstream fichier("test.txt", ios::out | ios::trunc);  // ouverture en écriture avec effacement du fichier ouvert
   fichier << "x=[";
   /*
   for (nb = 10; nb < 315; nb++)
     {
       mon_monge.construit_marginale(nb);
       mon_monge.construit_cout(nb);
       fichier <<  ", " << 1000*mon_monge.dual(nb);
     }
   */
   fichier << "]";
   fichier.close();
   
   return 0;


}



