#include "matrix.h"



interval_matrix expression_matrix::evalue(domain x)
{
  interval_matrix result;
  result.dependent_variable = dependent_variable;
  result.independent_variable = independent_variable;

  for (vector<string>::iterator i = dependent_variable.begin(); i!=dependent_variable.end(); ++i)
    {
      for (vector<string>::iterator j = independent_variable.begin(); j!=independent_variable.end(); ++j)
	{ 	  
	  result.c[*i][*j] = coefficient[*i][*j].Evalue(x);
	}
    }  
  return result;
}


expression expression_matrix::determinant(vector <string> dependent, vector <string> independent)
{
 if (dependent.size()==1) 
    {    
      expression result = coefficient[dependent[0]][independent[0]];
      //      cout << result.chaine << endl ;
      return result ;
    }
  else 

    {
      expression result = expression("0");
      int alterne = 1;

      for (int i = 0 ; i < dependent.size() ; i++ )
	{

	  expression coef = coefficient[dependent[i]][independent[0]];
	  //	  cout << coef << endl;
	  
	  vector <string > Dependent = dependent;
	  vector <string > Independent = independent;

	  Dependent.erase(Dependent.begin() + i);
      	  Independent.erase(Independent.begin());

	  if (alterne == 1)
	    result = result + expression("1")*coef*determinant(Dependent, Independent);
	  else 
	    result = result + expression("-1")*coef*determinant(Dependent, Independent);

	  alterne = -1 * alterne;
	}
      return result;
    }
};

expression expression_matrix::determinant()
{

  expression result = determinant(dependent_variable, independent_variable);
  return result;

};


interval interval_matrix::determinant(vector <string> dependent, vector <string> independent)
{
 if (dependent.size()==1) 
    {    
      interval result = c[dependent[0]][independent[0]];
      return result ;
    }
  else 

    {
      interval result = interval(0);
      int alterne = 1;

      for (int i = 0 ; i < dependent.size() ; i++ )
	{

	  interval coef = c[dependent[i]][independent[0]];
	  //	  cout << coef << endl;
	  
	  vector <string > Dependent = dependent;
	  vector <string > Independent = independent;

	  Dependent.erase(Dependent.begin() + i);
      	  Independent.erase(Independent.begin());

	  if (alterne == 1)
	    result = result + interval(1)*coef*determinant(Dependent, Independent);
	  else 
	    result = result + interval(-1)*coef*determinant(Dependent, Independent);

	  alterne = -1 * alterne;
	}
      return result;
    }
};



interval interval_matrix::determinant()
{

  interval result = determinant(dependent_variable, independent_variable);
  return result;

};




void interval_matrix::out()
{
  for( int dep = 0 ; dep< dependent_variable.size() ; dep++) 
    {
      for( int indep = 0 ; indep < independent_variable.size() ; indep++) 
	{ 
	  cout <<  dependent_variable[dep]  << "|"<< independent_variable[indep]  << ":"<< c[dependent_variable[dep]][independent_variable[indep]] << endl;
	}
    }
}


void expression_matrix::out()
{
  for( int dep = 0 ; dep< dependent_variable.size() ; dep++) 
    {
      for( int indep = 0 ; indep < independent_variable.size() ; indep++) 
	{ 
	  cout <<  dependent_variable[dep]  << "|"<< independent_variable[indep]  << ":"<< coefficient[dependent_variable[dep]][independent_variable[indep]].chaine << endl;
	}
    }
}


indice interval_matrix::pivot(vector <string> dependent, vector<string> independent)
{
  indice result;
  interval best ;
  best =  interval(0,0);
  for (vector<string>::iterator i = dependent.begin(); i!=dependent.end(); ++i)
    {
      for (vector<string>::iterator j = independent.begin(); j!=independent.end(); ++j)
	{ 
	  if ( c[*i][*j].mig() > best.mig()  && !c[*i][*j].contains(0) )
	    {
	      best = c[*i][*j];	       
	      result.dep = *i;
	      result.ind = *j;	       
	    }
	}
    }
  return result;
}


indice interval_matrix::pivot()
{
  return pivot(dependent_variable, independent_variable);
}



interval_matrix interval_matrix::gaussian(vector <string> dependent, vector<string> independent, interval_matrix M, domain & b)
{  

  indice ij = pivot(dependent, independent);
  //  cout << ij.dep << "," << ij.ind << " : " << M.c[ij.dep][ij.ind] << endl;	  	       

  interval_matrix next = M;
  domain next_b = b;

  for (vector<string>::iterator i = dependent.begin(); i!=dependent.end(); ++i)
    {
      for (vector<string>::iterator j = independent.begin(); j!=independent.end(); ++j)
	{ 	  
	  if (*j!=ij.ind && *i!=ij.dep)
	    next.c[*i][*j] = M.c[*i][*j] - M.c[ij.dep][*j] * M.c[*i][ij.ind] / M.c[ij.dep][ij.ind] ;

	  if (*j==ij.ind && *i!=ij.dep)
	    next.c[*i][*j] = 0;
	}
	  if (*i!=ij.dep)
	    next_b[*i] = b[*i] - (b[ij.dep] * M.c[*i][ij.ind]) / M.c[ij.dep][ij.ind];
     }

  b = next_b;
  /*  cout << "<wwwwwwwwwwwwwwwwwww" << endl;
  b.out();
  */
  return next;
};





domain interval_matrix::gaussian(domain b)
{   
  interval_matrix M = (*this);
  int dim = dependent_variable.size();

  vector <string> dependent, dependent_next;
  vector <string> independent, independent_next;

  vector < indice > pivots;

  dependent = dependent_variable;
  independent = independent_variable;

  int k;
  for (k=1 ; k < dim ; k++)
    {
      indice ij = pivot(dependent, independent);
      M = gaussian(dependent, independent, M, b);
      pivots.push_back(ij);
      
      // remove pivot from the list of independent and dependent variables
      dependent_next.clear();
      independent_next.clear();
      for (vector<string>::iterator i = dependent.begin(); i!=dependent.end(); ++i)
	{
	  if (*i != ij.dep)
	  dependent_next.push_back(*i);	  
	}

      for (vector<string>::iterator j = independent.begin(); j!=independent.end(); ++j)
	{
	  if (*j != ij.ind)
	  independent_next.push_back(*j);
	}

      dependent.clear();
      independent.clear();
      
      dependent = dependent_next;
      independent = independent_next;
    }

  string last_ind = independent[0];
  string last_dep = dependent[0];
  indice last_pivot;
  last_pivot.ind = last_ind;
  last_pivot.dep = last_dep;

  pivots.push_back(last_pivot);
  
  /*  cout << "____________________________________" << endl; 
  
  for (vector<string>::iterator i = dependent_variable.begin(); i!=dependent_variable.end(); ++i)
    {
      for (vector<string>::iterator j = independent_variable.begin(); j!=independent_variable.end(); ++j)
	{ 	  
	  cout << *i << "," << *j << " : " << M.c[*i][*j] << endl;	  	        
	}
    }
  */

  domain x;

  for (vector<indice>::reverse_iterator k = pivots.rbegin(); k!= pivots.rend(); ++k)
    {
      indice ij = *k;
      interval somme (0,0);
      for (vector<string>::iterator j = independent_variable.begin(); j!=independent_variable.end(); ++j)
	{ 	  
	  somme = somme + M.c[ij.dep][*j]*x[*j];
	}
      x[ij.ind] = (b[ij.dep] - somme) / M.c[ij.dep][ij.ind];
    }
  return x;
  
};


domain interval_matrix::row( string indep ) 
{
  domain result;
  for( int dep = 0 ; dep < dependent_variable.size() ; dep++) 
    { 
      result[dependent_variable[dep]] = c[dependent_variable[dep]][indep];
    }
  return result;
}



domain interval_matrix::image( domain x ) 
{
  domain result;


  for( int dep = 0 ; dep < dependent_variable.size() ; dep++) 
    { 
      result[dependent_variable[dep]] = interval(0);
        for( int indep = 0 ; indep < independent_variable.size() ; indep++) 
	  { 
	    result[dependent_variable[dep]] = result[dependent_variable[dep]] + c[dependent_variable[dep]][independent_variable[indep]]*x[independent_variable[indep]];
	  }
    }
  return result;
}

