#ifndef __MONGE__
#define __MONGE__


//---------------------------------------------------------------------------
#include "expression.h"
#include "domain.h"
#include "mesh.h"
#include "iboolean.h"

typedef filib::interval<double,filib::native_switched,filib::i_mode_extended> interval;


class monge
{
public :

  monge (expression mu  , expression nu , expression cost);

  expression f; //code mu
  expression g; //code nu

  domain X;
  domain Y;

  double x_min ;
  double x_max ;
  double y_min ;
  double y_max ;

  expression cout;

  vector <interval> f_i;
  vector <interval> g_j;
  vector < vector < interval > > cout_ij;

  void construit_marginale(int n);
  void construit_cout(int n);
  

  // fonction qui génère le problème primal et qui le résoud
  double primal(int n); 


  // fonction qui génère le problème dual et qui le résoud 

   double dual(int n);


};


//---------------------------------------------------------------------------
#endif
